#include<bits/stdc++.h>
using namespace std;
int a[1000000];
long long n;
long long res(long long k,long long l,long long r)
{
    if(k==0)
    {
        int sum=0;
        for(int i=l;i<=r;i++)
        {
            sum+=a[i];
            sum=sum%1000000007;
        }
        return sum;
    }
    else
    {
        long long sum=0,sum1=0;
        for(int i =l;i<=r;i++)
        {
            for(int j = i;j<=r;j++)
            {
                sum+=res(k-1,i,j);
                sum=sum%1000000007;
            }
        }
        return sum;
    }
}
int main()
{
    long long n,k;
    cin >> n >> k;

    for(int i =0;i<n;i++)
    {
        cin >> a[i];
    }
    cout << res(k,0,n-1);
}